/** @file server.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.21
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef SERVER_CMDLINE_H
#define SERVER_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef SERVER_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define SERVER_CMDLINE_PARSER_PACKAGE "para_server"
#endif

#ifndef SERVER_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define SERVER_CMDLINE_PARSER_VERSION "0.3.0"
#endif

/** @brief Where the command line options are stored */
struct server_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int loglevel_arg;	/**< @brief set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/**< @brief set loglevel (0-6) original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel (0-6) help description.  */
  int port_arg;	/**< @brief listening port (default='2990').  */
  char * port_orig;	/**< @brief listening port original value given at command line.  */
  const char *port_help; /**< @brief listening port help description.  */
  int daemon_flag;	/**< @brief run as background daemon (default=off).  */
  const char *daemon_help; /**< @brief run as background daemon help description.  */
  char * user_arg;	/**< @brief run as user 'name'. para_server does not
  need any special privileges. If started as
  root (EUID == 0) this option must be given at
  the command line (not in the configuration
  file) so that para_server can drop the root
  privileges right after parsing the command
  line options, but before parsing the
  configuration file. In this case,
  real/effective/saved UID are all set to the
  UID of 'name'. As the configuration file
  is read afterwards, those options that have a
  default value depending on the UID (e.g. the
  directory for the configuration file) are
  computed by using the uid of 'name'.
  This option has no effect if para_server is
  started as a non-root user (i.e.  EUID != 0).  */
  char * user_orig;	/**< @brief run as user 'name'. para_server does not
  need any special privileges. If started as
  root (EUID == 0) this option must be given at
  the command line (not in the configuration
  file) so that para_server can drop the root
  privileges right after parsing the command
  line options, but before parsing the
  configuration file. In this case,
  real/effective/saved UID are all set to the
  UID of 'name'. As the configuration file
  is read afterwards, those options that have a
  default value depending on the UID (e.g. the
  directory for the configuration file) are
  computed by using the uid of 'name'.
  This option has no effect if para_server is
  started as a non-root user (i.e.  EUID != 0) original value given at command line.  */
  const char *user_help; /**< @brief run as user 'name'. para_server does not
  need any special privileges. If started as
  root (EUID == 0) this option must be given at
  the command line (not in the configuration
  file) so that para_server can drop the root
  privileges right after parsing the command
  line options, but before parsing the
  configuration file. In this case,
  real/effective/saved UID are all set to the
  UID of 'name'. As the configuration file
  is read afterwards, those options that have a
  default value depending on the UID (e.g. the
  directory for the configuration file) are
  computed by using the uid of 'name'.
  This option has no effect if para_server is
  started as a non-root user (i.e.  EUID != 0) help description.  */
  char * group_arg;	/**< @brief set group id to according to 'group'. This
  option is silently ignored if EUID != 0.
  Otherwise, real/effective GID and the saved
  set-group ID are all set to the GID given by
  'group'. Must not be given in the config file..  */
  char * group_orig;	/**< @brief set group id to according to 'group'. This
  option is silently ignored if EUID != 0.
  Otherwise, real/effective GID and the saved
  set-group ID are all set to the GID given by
  'group'. Must not be given in the config file. original value given at command line.  */
  const char *group_help; /**< @brief set group id to according to 'group'. This
  option is silently ignored if EUID != 0.
  Otherwise, real/effective GID and the saved
  set-group ID are all set to the GID given by
  'group'. Must not be given in the config file. help description.  */
  char * logfile_arg;	/**< @brief (default=stdout/stderr).  */
  char * logfile_orig;	/**< @brief (default=stdout/stderr) original value given at command line.  */
  const char *logfile_help; /**< @brief (default=stdout/stderr) help description.  */
  char * config_file_arg;	/**< @brief (default='~/.paraslash/server.conf'.  */
  char * config_file_orig;	/**< @brief (default='~/.paraslash/server.conf' original value given at command line.  */
  const char *config_file_help; /**< @brief (default='~/.paraslash/server.conf' help description.  */
  char * user_list_arg;	/**< @brief (default='~/.paraslash/server.users').  */
  char * user_list_orig;	/**< @brief (default='~/.paraslash/server.users') original value given at command line.  */
  const char *user_list_help; /**< @brief (default='~/.paraslash/server.users') help description.  */
  int autoplay_flag;	/**< @brief start playing on startup (default=off).  */
  const char *autoplay_help; /**< @brief start playing on startup help description.  */
  int autoplay_delay_arg;	/**< @brief Time to wait before autoplay starts. Ignored if
  autoplay is off. (default='0').  */
  char * autoplay_delay_orig;	/**< @brief Time to wait before autoplay starts. Ignored if
  autoplay is off. original value given at command line.  */
  const char *autoplay_delay_help; /**< @brief Time to wait before autoplay starts. Ignored if
  autoplay is off. help description.  */
  int announce_time_arg;	/**< @brief Delay betweeen announcing the stream and sending data (default='300').  */
  char * announce_time_orig;	/**< @brief Delay betweeen announcing the stream and sending data original value given at command line.  */
  const char *announce_time_help; /**< @brief Delay betweeen announcing the stream and sending data help description.  */
  char * afs_database_dir_arg;	/**< @brief Directory containing the osl database of the
  audio file selector.
  (default='~/.paraslash/afs_database'.  */
  char * afs_database_dir_orig;	/**< @brief Directory containing the osl database of the
  audio file selector.
  (default='~/.paraslash/afs_database' original value given at command line.  */
  const char *afs_database_dir_help; /**< @brief Directory containing the osl database of the
  audio file selector.
  (default='~/.paraslash/afs_database' help description.  */
  char * afs_socket_arg;	/**< @brief Command socket for the audio file selector (default='/var/paraslash/afs_command_socket').  */
  char * afs_socket_orig;	/**< @brief Command socket for the audio file selector original value given at command line.  */
  const char *afs_socket_help; /**< @brief Command socket for the audio file selector help description.  */
  char * afs_initial_mode_arg;	/**< @brief Mood or playlist to load on startup. Must be
  prefixed with either 'p/' or 'm/' to indicate
  whether a playlist or a mood should be
  loaded. Example:
  	--afs_initial_mode p/foo
  loads the playlist named 'foo'..  */
  char * afs_initial_mode_orig;	/**< @brief Mood or playlist to load on startup. Must be
  prefixed with either 'p/' or 'm/' to indicate
  whether a playlist or a mood should be
  loaded. Example:
  	--afs_initial_mode p/foo
  loads the playlist named 'foo'. original value given at command line.  */
  const char *afs_initial_mode_help; /**< @brief Mood or playlist to load on startup. Must be
  prefixed with either 'p/' or 'm/' to indicate
  whether a playlist or a mood should be
  loaded. Example:
  	--afs_initial_mode p/foo
  loads the playlist named 'foo'. help description.  */
  int http_port_arg;	/**< @brief tcp port for http streaming (default='8000').  */
  char * http_port_orig;	/**< @brief tcp port for http streaming original value given at command line.  */
  const char *http_port_help; /**< @brief tcp port for http streaming help description.  */
  int http_default_deny_flag;	/**< @brief deny connections from hosts which are not
  explicitly allowed (default=off).  */
  const char *http_default_deny_help; /**< @brief deny connections from hosts which are not
  explicitly allowed help description.  */
  char ** http_access_arg;	/**< @brief Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x.  */
  char ** http_access_orig;	/**< @brief Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x original value given at command line.  */
  int http_access_min; /**< @brief Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x's minimum occurreces */
  int http_access_max; /**< @brief Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x's maximum occurreces */
  const char *http_access_help; /**< @brief Add given host/network to access control
  list (whitelist if http_default_deny was
  given, blacklist otherwise) before opening
  the tcp port. This option can be given
  multiple times. Example: '192.168.0.0/24'
  whitelists/blacklists the 256 hosts
  192.168.0.x help description.  */
  int http_no_autostart_flag;	/**< @brief do not open tcp port on server startup (default=off).  */
  const char *http_no_autostart_help; /**< @brief do not open tcp port on server startup help description.  */
  int http_max_clients_arg;	/**< @brief maximal simultaneous connections,
  non-positive value means unlimited (default='-1').  */
  char * http_max_clients_orig;	/**< @brief maximal simultaneous connections,
  non-positive value means unlimited original value given at command line.  */
  const char *http_max_clients_help; /**< @brief maximal simultaneous connections,
  non-positive value means unlimited help description.  */
  int dccp_port_arg;	/**< @brief port for dccp streaming (default='5001').  */
  char * dccp_port_orig;	/**< @brief port for dccp streaming original value given at command line.  */
  const char *dccp_port_help; /**< @brief port for dccp streaming help description.  */
  char ** ortp_target_arg;	/**< @brief Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming..  */
  char ** ortp_target_orig;	/**< @brief Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming. original value given at command line.  */
  int ortp_target_min; /**< @brief Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming.'s minimum occurreces */
  int ortp_target_max; /**< @brief Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming.'s maximum occurreces */
  const char *ortp_target_help; /**< @brief Add given host/port to the list of targets.
  This option can be given multiple times.
  Example: '224.0.1.38:1500' instructs the ortp
  sender to send to udp port 1500 on host
  224.0.1.38 (unassigned ip in the Local
  Network Control Block 224.0.0/24). This is
  useful for LAN-streaming. help description.  */
  int ortp_no_autostart_flag;	/**< @brief do not start to send automatically (default=off).  */
  const char *ortp_no_autostart_help; /**< @brief do not start to send automatically help description.  */
  int ortp_default_port_arg;	/**< @brief default udp port if not specified (default='1500').  */
  char * ortp_default_port_orig;	/**< @brief default udp port if not specified original value given at command line.  */
  const char *ortp_default_port_help; /**< @brief default udp port if not specified help description.  */
  int ortp_header_interval_arg;	/**< @brief time between extra header sends (default='2000').  */
  char * ortp_header_interval_orig;	/**< @brief time between extra header sends original value given at command line.  */
  const char *ortp_header_interval_help; /**< @brief time between extra header sends help description.  */
  int ortp_jitter_compensation_arg;	/**< @brief non-zero values enable ortp's adaptive
  jitter compensation (default='400').  */
  char * ortp_jitter_compensation_orig;	/**< @brief non-zero values enable ortp's adaptive
  jitter compensation original value given at command line.  */
  const char *ortp_jitter_compensation_help; /**< @brief non-zero values enable ortp's adaptive
  jitter compensation help description.  */
  
  int help_given ;	/**< @brief Whether help was given.  */
  int version_given ;	/**< @brief Whether version was given.  */
  int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  int port_given ;	/**< @brief Whether port was given.  */
  int daemon_given ;	/**< @brief Whether daemon was given.  */
  int user_given ;	/**< @brief Whether user was given.  */
  int group_given ;	/**< @brief Whether group was given.  */
  int logfile_given ;	/**< @brief Whether logfile was given.  */
  int config_file_given ;	/**< @brief Whether config_file was given.  */
  int user_list_given ;	/**< @brief Whether user_list was given.  */
  int autoplay_given ;	/**< @brief Whether autoplay was given.  */
  int autoplay_delay_given ;	/**< @brief Whether autoplay_delay was given.  */
  int announce_time_given ;	/**< @brief Whether announce_time was given.  */
  int afs_database_dir_given ;	/**< @brief Whether afs_database_dir was given.  */
  int afs_socket_given ;	/**< @brief Whether afs_socket was given.  */
  int afs_initial_mode_given ;	/**< @brief Whether afs_initial_mode was given.  */
  int http_port_given ;	/**< @brief Whether http_port was given.  */
  int http_default_deny_given ;	/**< @brief Whether http_default_deny was given.  */
  unsigned int http_access_given ;	/**< @brief Whether http_access was given.  */
  int http_no_autostart_given ;	/**< @brief Whether http_no_autostart was given.  */
  int http_max_clients_given ;	/**< @brief Whether http_max_clients was given.  */
  int dccp_port_given ;	/**< @brief Whether dccp_port was given.  */
  unsigned int ortp_target_given ;	/**< @brief Whether ortp_target was given.  */
  int ortp_no_autostart_given ;	/**< @brief Whether ortp_no_autostart was given.  */
  int ortp_default_port_given ;	/**< @brief Whether ortp_default_port was given.  */
  int ortp_header_interval_given ;	/**< @brief Whether ortp_header_interval was given.  */
  int ortp_jitter_compensation_given ;	/**< @brief Whether ortp_jitter_compensation was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct server_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure server_args_info (default 0) */
  int check_required; /**< @brief whether to check that all required options were provided (default 0) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure server_args_info (default 0) */
} ;

/** @brief the purpose string of the program */
extern const char *server_args_info_purpose;
/** @brief the usage string of the program */
extern const char *server_args_info_usage;
/** @brief all the lines making the help output */
extern const char *server_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int server_cmdline_parser (int argc, char * const *argv,
  struct server_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use server_cmdline_parser_ext() instead
 */
int server_cmdline_parser2 (int argc, char * const *argv,
  struct server_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int server_cmdline_parser_ext (int argc, char * const *argv,
  struct server_args_info *args_info,
  struct server_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int server_cmdline_parser_file_save(const char *filename,
  struct server_args_info *args_info);

/**
 * Print the help
 */
void server_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void server_cmdline_parser_print_version(void);

/**
 * Allocates dynamically a server_cmdline_parser_params structure and initializes
 * all its fields to 0
 * @return the initialized server_cmdline_parser_params structure
 */
struct server_cmdline_parser_params *server_cmdline_parser_params_init(void);

/**
 * Initializes the passed server_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void server_cmdline_parser_init (struct server_args_info *args_info);
/**
 * Deallocates the string fields of the server_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void server_cmdline_parser_free (struct server_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use server_cmdline_parser_config_file() instead
 */
int server_cmdline_parser_configfile (char * const filename,
  struct server_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int server_cmdline_parser_config_file (char * const filename,
  struct server_args_info *args_info,
  struct server_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int server_cmdline_parser_required (struct server_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* SERVER_CMDLINE_H */
